
#ifndef SCBAPI_C
#define SCBAPI_C

/*
requires wininet.lib
*/

#include <windows.h>
#include <wininet.h>
#include "scbapi.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

HINTERNET hInet = NULL;
char *SCBAPI_LastErrorText = NULL;
int SCBAPI_LastErrorCode = 0;

int SCBAPI_Init()
{
	SCBAPI_LastErrorText = NULL;
	return ((hInet = InternetOpen("SCBAPI",INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0))!=NULL);
}

int SCBAPI_Free()
{
	BOOL Result = InternetCloseHandle(hInet);
	if (Result)
		hInet = NULL;
	free(SCBAPI_LastErrorText);
	SCBAPI_LastErrorText = NULL;
	SCBAPI_LastErrorCode = 0;
	return Result;
}

char *SCBAPI_SendRecv(char *tsURL, char *tsData)
{
	#ifdef SCBAPI_DEBUG
	if (tsData)
	{		
		FILE *fReq = fopen("request.xml.txt","wb");
		fputs(tsData,fReq);
		fclose(fReq);
	}
	#endif // SCBAPI_DEBUG

	URL_COMPONENTS URL;
	memset(&URL,0,sizeof(URL_COMPONENTS));
	URL.dwStructSize = sizeof(URL_COMPONENTS);
	char Host[1024],Path[1024];
	memset(Host,0,1024), memset(Path,0,1024);
	URL.lpszHostName = Host;
	URL.dwHostNameLength = 1024;
	URL.lpszUrlPath = Path;
	URL.dwUrlPathLength = 1024;
	if (InternetCrackUrl(tsURL,0,0,&URL))
	{
		INTERNET_PORT Port = INTERNET_DEFAULT_HTTP_PORT;
		if (URL.nPort!=0) Port = URL.nPort;
		HINTERNET hConn = InternetConnect(hInet,Host,Port,"",NULL,INTERNET_SERVICE_HTTP,0,0);
		if (hConn)
		{
			HINTERNET hRequest = HttpOpenRequest(hConn,"POST",Path,"HTTP/1.0",NULL,NULL,INTERNET_FLAG_DONT_CACHE | INTERNET_FLAG_KEEP_CONNECTION | INTERNET_FLAG_NO_CACHE_WRITE,0);
			if (hRequest)
			{
				if (HttpSendRequest(hRequest,NULL,0,tsData,strlen(tsData)))
				{
					char *Response = NULL;
					DWORD dwSize = 0;
					HttpQueryInfo(hRequest,HTTP_QUERY_STATUS_CODE,NULL,&dwSize,0);
					char *tsStatus = (char *)malloc(dwSize+1);
					memset(tsStatus,0,dwSize+1);
					HttpQueryInfo(hRequest,HTTP_QUERY_STATUS_CODE,tsStatus,&dwSize,0);
					SCBAPI_LastErrorCode = atoi(tsStatus);
					free(tsStatus);

					if (SCBAPI_LastErrorCode==HTTP_STATUS_OK)
					{
						Response = (char *)malloc(1);
						Response[0] = '\0';
						unsigned long RespLen = 0;
						unsigned long RespAlc = 0;
						BOOL ReadResult = TRUE;
						DWORD BytesRead = 10241;
						char Buffer[10241];
						unsigned short Available = 1;

						while (Available && ReadResult && BytesRead>0)
						{
							memset(Buffer,0,10240);
							BytesRead = 0;
							ReadResult = InternetReadFile(hRequest,Buffer,10240,&BytesRead);
							if (ReadResult && BytesRead>0)
							{
								if (RespLen+BytesRead>RespAlc)
								{
									char *tsResponse = Response;
									Response = (char *)realloc(Response,RespAlc+BytesRead+SCBAPI_INCREASE+1);
									if (!Response)
									{
										char tsMsg[1024];
										sprintf(tsMsg,"Fatal error while reallocating (%u->%u) memory! Please report to developers.",RespAlc,RespAlc+BytesRead+SCBAPI_INCREASE+1);
										MessageBox(NULL,tsMsg,"SCBAPI Error",MB_OK | MB_ICONERROR);
										Available = 0;
										Response = tsResponse;
									}

									if (Available)
									{
										memset(Response+RespLen,0,SCBAPI_INCREASE+BytesRead+1);
										RespAlc += SCBAPI_INCREASE+BytesRead;
									}
								}

								if (Available)
								{
									strncpy(Response+RespLen,Buffer,BytesRead);
									RespLen += BytesRead;
									//Response[RespLen] = '\0';
								}
							}
						}

						#ifdef SCBAPI_DEBUG
						if (1)
						{
							FILE *fRes = fopen("response.xml.txt","wb");
							fputs(Response,fRes);
							fclose(fRes);
						}
						#endif // SCBAPI_DEBUG
					}
					else
					{
						Response = (char *)SCBAPI_ERR_HTTP;
						dwSize = 0;
						HttpQueryInfo(hRequest,HTTP_QUERY_STATUS_TEXT,NULL,&dwSize,0);
						SCBAPI_LastErrorText = (char *)realloc(SCBAPI_LastErrorText,dwSize+1);
						memset(SCBAPI_LastErrorText,0,dwSize+1);
						HttpQueryInfo(hRequest,HTTP_QUERY_STATUS_TEXT,SCBAPI_LastErrorText,&dwSize,0);
					}

					InternetCloseHandle(hRequest);
					return Response;
				}
				else
				{
					DWORD err = GetLastError();
					InternetCloseHandle(hConn);
					return (char *)SCBAPI_ERR_REQSEND;
				}				
			}
			else
				return (char *)SCBAPI_ERR_REQUEST;
		}
		else
			return (char *)SCBAPI_ERR_CONNECT;
	}
	else
		return (char *)SCBAPI_ERR_INVURL;
}

int SCBAPI_GetError(char *tsBuffer, int iBufSize)
{
	if (SCBAPI_LastErrorText)
	{
		if (tsBuffer && iBufSize>0)
		{
			if (strlen(SCBAPI_LastErrorText)+1<=(unsigned int)iBufSize)
				strcpy(tsBuffer,SCBAPI_LastErrorText);
			else
				strncpy(tsBuffer,SCBAPI_LastErrorText,iBufSize-1);
		}
	}

	return SCBAPI_LastErrorCode;
}

char *SCBAPI_Command(char *tsURL, char *tsCommand, char *tsContent, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	unsigned int xmlLen = 0;
	if (tsCommand) xmlLen += strlen(tsCommand);
	if (tsContent) xmlLen += strlen(tsContent);
	if (tsEncoding) xmlLen += strlen(tsEncoding);
	if (tsStorage) xmlLen += strlen(tsStorage);
	if (tsUser) xmlLen += strlen(tsUser);
	if (tsPassword) xmlLen += strlen(tsPassword);
	char *xmlData = (char *)malloc(xmlLen+1024);
	memset(xmlData,0,xmlLen+1024);
	unsigned int xmlUsed = 0;
	char tsTime[1024], tsStamp[1024];
	memset(tsTime,0,1024); memset(tsStamp,0,1024);
	time_t lTime;

	time(&lTime);
	strftime(tsTime,1024,"%Y-%m-%d %H:%M:%S",localtime(&lTime));
	//strftime(tsStamp,1024,"%Y%m%d%H%M%S",localtime(&lTime));
	sprintf(tsStamp,"%u",lTime);

	sprintf(xmlData+xmlUsed,"<?xml version=\"1.0\" encoding=\"%s\"?>\n",tsEncoding);
	xmlUsed += 34+strlen(tsEncoding);
	sprintf(xmlData+xmlUsed,"<siets:request xmlns:siets=\"www.siets.net\">\n");
	xmlUsed += 44;
	sprintf(xmlData+xmlUsed,"<siets:storage>%s</siets:storage>\n",tsStorage);
	xmlUsed += 32+strlen(tsStorage);
	sprintf(xmlData+xmlUsed,"<siets:timestamp>%s</siets:timestamp>\n",tsTime);
	xmlUsed += 36+strlen(tsTime);;
	sprintf(xmlData+xmlUsed,"<siets:command>%s</siets:command>\n",tsCommand);
	xmlUsed += 32+strlen(tsCommand);
	sprintf(xmlData+xmlUsed,"<siets:requestid>%s</siets:requestid>\n",tsStamp);
	xmlUsed += 36+strlen(tsStamp);
	sprintf(xmlData+xmlUsed,"<siets:user>%s</siets:user>\n",tsUser);
	xmlUsed += 26+strlen(tsUser);
	sprintf(xmlData+xmlUsed,"<siets:password>%s</siets:password>\n",tsPassword);
	xmlUsed += 34+strlen(tsPassword);
	sprintf(xmlData+xmlUsed,"<siets:reply_charset>%s</siets:reply_charset>\n",tsEncoding);
	xmlUsed += 44+strlen(tsEncoding);
	if (tsContent && tsContent[0]!='\0')
	{
		sprintf(xmlData+xmlUsed,"<siets:content>%s</siets:content>\n",tsContent);
		xmlUsed += 32+strlen(tsContent);
	}
	sprintf(xmlData+xmlUsed,"</siets:request>\n");
	xmlUsed += 17;

	char *Result = SCBAPI_SendRecv(tsURL,xmlData);

	free(xmlData);
	
	return Result;
}

char *SCBAPI_Status(char *tsURL, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	return SCBAPI_Command(tsURL,"status",NULL,tsEncoding,tsStorage,tsUser,tsPassword);
}

char *SCBAPI_Insert(char *tsURL, char *tsID, char *tsTitle, unsigned long iRate, char *tsText, char *tsInfo, char *tsSpectags, char *tsOptional, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	char tsRate[64];
	sprintf(tsRate,"%u",iRate);
	unsigned int xmlLen = 0;
	if (tsID) xmlLen += strlen(tsID);
	if (tsTitle) xmlLen += strlen(tsTitle);
	if (tsRate) xmlLen += strlen(tsRate);
	if (tsText) xmlLen += strlen(tsText);
	if (tsInfo) xmlLen += strlen(tsInfo);
	if (tsSpectags) xmlLen += strlen(tsSpectags);
	if (tsOptional) xmlLen += strlen(tsOptional);
	char *xmlData = (char *)malloc(xmlLen+1024);
	memset(xmlData,0,xmlLen+1024);
	unsigned int xmlUsed = 0;

	sprintf(xmlData+xmlUsed,"<document>\n");
	xmlUsed += 11;
	sprintf(xmlData+xmlUsed,"<id>%s</id>\n",tsID);
	xmlUsed += 10+strlen(tsID);
	sprintf(xmlData+xmlUsed,"<title>%s</title>\n",tsTitle);
	xmlUsed += 16+strlen(tsTitle);
	sprintf(xmlData+xmlUsed,"<info>%s</info>\n",tsInfo);
	xmlUsed += 14+strlen(tsInfo);
	sprintf(xmlData+xmlUsed,"<rate>%s</rate>\n",tsRate);
	xmlUsed += 14+strlen(tsRate);
	sprintf(xmlData+xmlUsed,"<text>%s</text>\n",tsText);
	xmlUsed += 14+strlen(tsText);
	sprintf(xmlData+xmlUsed,"<spectags>%s</spectags>\n",tsSpectags);
	xmlUsed += 22+strlen(tsSpectags);
	if (tsOptional)
	{
		strcpy(xmlData+xmlUsed,tsOptional);
		xmlUsed += strlen(tsOptional);
	}
	sprintf(xmlData+xmlUsed,"</document>");
	xmlUsed += 11;
	char *Result = SCBAPI_Command(tsURL,"insert",xmlData,tsEncoding,tsStorage,tsUser,tsPassword);
	free(xmlData);
	return Result;
}

char *SCBAPI_Update(char *tsURL, char *tsID, char *tsTitle, unsigned long iRate, char *tsText, char *tsInfo, char *tsSpectags, char *tsOptional, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	char tsRate[64];
	sprintf(tsRate,"%u",iRate);
	unsigned int xmlLen = 0;
	if (tsID) xmlLen += strlen(tsID);
	if (tsTitle) xmlLen += strlen(tsTitle);
	if (tsRate) xmlLen += strlen(tsRate);
	if (tsText) xmlLen += strlen(tsText);
	if (tsInfo) xmlLen += strlen(tsInfo);
	if (tsSpectags) xmlLen += strlen(tsSpectags);
	if (tsOptional) xmlLen += strlen(tsOptional);
	char *xmlData = (char *)malloc(xmlLen+1024);
	memset(xmlData,0,xmlLen+1024);
	unsigned int xmlUsed = 0;

	sprintf(xmlData+xmlUsed,"<document>\n");
	xmlUsed += 11;
	sprintf(xmlData+xmlUsed,"<id>%s</id>\n",tsID);
	xmlUsed += 10+strlen(tsID);
	sprintf(xmlData+xmlUsed,"<title>%s</title>\n",tsTitle);
	xmlUsed += 16+strlen(tsTitle);
	sprintf(xmlData+xmlUsed,"<info>%s</info>\n",tsInfo);
	xmlUsed += 14+strlen(tsInfo);
	sprintf(xmlData+xmlUsed,"<rate>%s</rate>\n",tsRate);
	xmlUsed += 14+strlen(tsRate);
	sprintf(xmlData+xmlUsed,"<text>%s</text>\n",tsText);
	xmlUsed += 14+strlen(tsText);
	sprintf(xmlData+xmlUsed,"<spectags>%s</spectags>\n",tsSpectags);
	xmlUsed += 22+strlen(tsSpectags);
	if (tsOptional)
	{
		strcpy(xmlData+xmlUsed,tsOptional);
		xmlUsed += strlen(tsOptional);
	}
	sprintf(xmlData+xmlUsed,"</document>");
	xmlUsed += 11;
	char *Result = SCBAPI_Command(tsURL,"update",xmlData,tsEncoding,tsStorage,tsUser,tsPassword);
	free(xmlData);
	return Result;
}

char *SCBAPI_Clear(char *tsURL, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	return SCBAPI_Command(tsURL,"clear",NULL,tsEncoding,tsStorage,tsUser,tsPassword);
}

char *SCBAPI_Retrieve(char *tsURL, char *tsID, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	unsigned int xmlLen = 0;
	if (tsID) xmlLen += strlen(tsID);
	char *xmlData = (char *)malloc(xmlLen+1024);
	memset(xmlData,0,xmlLen+1024);
	unsigned int xmlUsed = 0;

	sprintf(xmlData+xmlUsed,"<document>\n");
	xmlUsed += 11;
	sprintf(xmlData+xmlUsed,"<id>%s</id>\n",tsID);
	xmlUsed += 10+strlen(tsID);
	sprintf(xmlData+xmlUsed,"</document>");
	xmlUsed += 11;
	char *Result = SCBAPI_Command(tsURL,"retrieve",xmlData,tsEncoding,tsStorage,tsUser,tsPassword);
	free(xmlData);
	return Result;
}

char *SCBAPI_Lookup(char *tsURL, char *tsID, char *tsEncoding, char *tsStorage, char *tsUser, char *tsPassword)
{
	unsigned int xmlLen = 0;
	if (tsID) xmlLen += strlen(tsID);
	char *xmlData = (char *)malloc(xmlLen+1024);
	memset(xmlData,0,xmlLen+1024);
	unsigned int xmlUsed = 0;

	sprintf(xmlData+xmlUsed,"<document>\n");
	xmlUsed += 11;
	sprintf(xmlData+xmlUsed,"<id>%s</id>\n",tsID);
	xmlUsed += 10+strlen(tsID);
	sprintf(xmlData+xmlUsed,"</document>");
	xmlUsed += 11;
	char *Result = SCBAPI_Command(tsURL,"lookup",xmlData,tsEncoding,tsStorage,tsUser,tsPassword);
	free(xmlData);
	return Result;
}

int SCBAPI_SietsError(char *tsResponse, SCBAPI_SIETS_ERROR *sError)
{
	char *Error = SCBAPI_ExtractTag(tsResponse,"siets:error",0);
	if (Error)
	{
		if (sError)
		{
			char *tmp = SCBAPI_ExtractTag(Error,"code",0);
			sError->code = atoi(tmp);
			free(tmp);
			sError->level = SCBAPI_ExtractTag(Error,"level",0);
			sError->source = SCBAPI_ExtractTag(Error,"source",0);
			sError->text = SCBAPI_ExtractTag(Error,"text",0);
		}
		free(Error);
		return 1;
	}
	else
	{
		if (sError)
			memset(sError,0,sizeof(SCBAPI_SIETS_ERROR));
		return 0;
	}
}

void SCBAPI_SietsErrorFree(SCBAPI_SIETS_ERROR *sError)
{
	free(sError->level);
	free(sError->source);
	free(sError->text);
	memset(sError,0,sizeof(SCBAPI_SIETS_ERROR));
}

char *SCBAPI_ExtractTag(char *tsData, char *tsTag, unsigned int nr)
{
	if (tsData)
	{
		char *pos1 = NULL, *pos2 = NULL, *pos3 = NULL;
		char tago[1024], tagc[1024];
		unsigned int len = 0;

		sprintf(tago,"<%s",tsTag);
		sprintf(tagc,"</%s>",tsTag);

		if ((pos1 = strstr(tsData,tago))!=NULL && (pos2 = strchr(pos1,'>'))!=NULL && (pos3 = strstr(tsData,tagc))!=NULL && pos2<pos3)
		{
			len = pos2-pos1+1;
			char *Result = (char *)malloc(pos3-pos1-len+1);
			strncpy(Result,pos1+len,pos3-pos1-len+1);
			Result[pos3-pos1-len] = '\0';
			return Result;
		}
		else
			return NULL;
	}
	else
		return NULL;
}

char *SCBAPI_XMLEntitiesEncode(char *tsString)
{
	if (tsString)
	{
		unsigned int uiLen = strlen(tsString);
		unsigned int uiAlc = uiLen;
		unsigned int uiUsd = 0;
		unsigned int i = 0;
		char *tsResult = (char *)malloc(uiAlc+1);
		memset(tsResult,0,uiAlc+1);

		i = 0;
		while (i<uiLen)
		{
			switch (tsString[i])
			{
				case '<':
					if (uiAlc<uiUsd+4)
					{
						tsResult = (char *)realloc(tsResult,uiAlc+4+1);
						uiAlc += 4;
					}
					strcpy(tsResult+uiUsd,"&lt;");
					uiUsd += 4;
					break;
				case '>':
					if (uiAlc<uiUsd+4)
					{
						tsResult = (char *)realloc(tsResult,uiAlc+4+1);
						uiAlc += 4;
					}
					strcpy(tsResult+uiUsd,"&gt;");
					uiUsd += 4;
					break;
				case '&':
					if (_strnicmp(tsString+i,"&nbsp;",6)==0)
					{
						if (uiAlc<uiUsd+1)
						{
							tsResult = (char *)realloc(tsResult,uiAlc+1+1);
							uiAlc += 1;
						}
						tsResult[uiUsd] = ' ';
						uiUsd++;
						i += 5;
					}
					else
					{
						if (uiAlc<uiUsd+5)
						{
							tsResult = (char *)realloc(tsResult,uiAlc+5+1);
							uiAlc += 5;
						}
						strcpy(tsResult+uiUsd,"&amp;");
						uiUsd += 5;
					}
					break;
				case '\'':
					if (uiAlc<uiUsd+6)
					{
						tsResult = (char *)realloc(tsResult,uiAlc+6+1);
						uiAlc += 6;
					}
					strcpy(tsResult+uiUsd,"&apos;");
					uiUsd += 6;
					break;
				case '"':
					if (uiAlc<uiUsd+6)
					{
						tsResult = (char *)realloc(tsResult,uiAlc+6+1);
						uiAlc += 6;
					}
					strcpy(tsResult+uiUsd,"&quot;");
					uiUsd += 6;
					break;
				default:
					if (uiAlc<uiUsd+1)
					{
						tsResult = (char *)realloc(tsResult,uiAlc+1+1);
						uiAlc += 1;
					}
					tsResult[uiUsd] = tsString[i];
					uiUsd++;
					break;
			}
			i++;
		}
		tsResult[uiUsd] = '\0';
		return tsResult;
	}
	else
		return NULL;
}

void SCBAPI_ReplaceSpecial(char **tsData)
{
	if (tsData && *tsData)
	{
		unsigned int uiLen = strlen(*tsData);
		unsigned int i = 0;
		unsigned int uiSC = 0;
		for (i=0;i<uiLen;i++)
			if ((*tsData)[i]=='@' || (*tsData)[i]=='-' || (*tsData)[i]=='.' || (*tsData)[i]==' ' || (*tsData)[i]=='_')
				uiSC++;

		if (uiSC>0)
		{
			i = 0;
			(*tsData) = (char *)realloc((*tsData),uiLen+3*uiSC+1);
			memset((*tsData)+uiLen,0,3*uiSC+1);
			while (i<uiLen)
			{
				if ((*tsData)[i]=='@')
				{
					memmove((*tsData)+i+3,(*tsData)+i+1,uiLen-i);
					strncpy((*tsData)+i,"_a_",3);
					uiLen += 2;
					i += 3;
					continue;
				}
				if ((*tsData)[i]=='-')
				{
					memmove((*tsData)+i+3,(*tsData)+i+1,uiLen-i);
					strncpy((*tsData)+i,"_m_",3);
					uiLen += 2;
					i += 3;
					continue;
				}
				if ((*tsData)[i]=='.')
				{
					memmove((*tsData)+i+3,(*tsData)+i+1,uiLen-i);
					strncpy((*tsData)+i,"_d_",3);
					uiLen += 2;
					i += 3;
					continue;
				}
				if ((*tsData)[i]==' ')
				{
					memmove((*tsData)+i+3,(*tsData)+i+1,uiLen-i);
					strncpy((*tsData)+i,"_s_",3);
					uiLen += 2;
					i += 3;
					continue;
				}
				if ((*tsData)[i]=='_')
				{
					memmove((*tsData)+i+3,(*tsData)+i+1,uiLen-i);
					strncpy((*tsData)+i,"_u_",3);
					uiLen += 2;
					i += 3;
					continue;
				}				
				i++;
			}
		}
	}
}

int SCBAPI_DisplayError(HWND hWnd, char *tsResponse)
{
	if (SCBAPI_IS_ERROR(tsResponse))
	{
		char tsBuffer[1024];
		memset(tsBuffer,0,1024);
		switch ((int)tsResponse)
		{
			case SCBAPI_ERR_INVURL:
				strcpy(tsBuffer,"Invalid URL syntax.");
				break;
			case SCBAPI_ERR_CONNECT:
				strcpy(tsBuffer,"Error during connection.");
				break;
			case SCBAPI_ERR_REQUEST:
				strcpy(tsBuffer,"Error forming request.");
				break;
			case SCBAPI_ERR_REQSEND:
				strcpy(tsBuffer,"Error sending request.");
				break;
			case SCBAPI_ERR_HTTP:
				if (1)
				{
					char tsBuf2[1024];
					memset(tsBuf2,0,1024);
					int iErr = SCBAPI_GetError(tsBuf2,1024);
					sprintf(tsBuffer,"HTTP error %d: %s.",iErr,tsBuf2);
				}
				break;
			default:
				sprintf(tsBuffer,"SCBAPI unknown error (%d).",(int)tsResponse);
				break;
		}
		MessageBox(hWnd,tsBuffer,"SCBAPI Error",MB_OK | MB_ICONERROR);
		return 1;
		
	}
	else
	{
		SCBAPI_SIETS_ERROR sse;
		if (SCBAPI_SietsError(tsResponse,&sse))
		{
			char tsBuffer[1024];
			sprintf(tsBuffer,"SIETS error. Error code %d: %s (%s %s)",sse.code,sse.text,sse.source,sse.level);
			MessageBox(hWnd,tsBuffer,"SIETS Error",MB_OK | MB_ICONERROR);
			SCBAPI_SietsErrorFree(&sse);
			return 1;
		}
		else
			return 0;
	}
}

#endif // SCBAPI_C
